/*
 *  TOPPERS/SSP Kernel
 *      Smallest Set Profile Kernel
 *
 *  Copyright (C) 2008 by Witz Corporation, JAPAN
 *  Copyright (C) 2010-2014 by Naoki Saito
 *             Nagoya Municipal Industrial Research Institute, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEEρE
 *  ĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒쌠
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[X
 *      R[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎgp
 *      ł`ōĔzzꍇɂ́CĔzzɔhLgip҃}
 *      jAȂǁjɁCL̒쌠\C̗pщL̖
 *      ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎgp
 *      łȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        \C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNgɕ
 *        邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD܂C
 *      {\tgEFÃ[U܂̓Gh[ÛȂ闝RɊ
 *      CL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړIɑ΂
 *  K܂߂āCȂۏ؂sȂD܂C{\tgEFA̗p
 *  ɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC
 *  ȂD
 * 
 */

/*
 *  RL78/G13Ɉˑ`
 */


#ifndef TOPPERS_RL78G13_H
#define TOPPERS_RL78G13_H

/*
 *  CPUOnhԍ̒`
 */
#define EXCNO_BRK	0	/* \tgEFAxN^ݖ */

/*
 *  ݔԍ̒`(ftHgvCIeB̒lݔԍƂ)
 */
#define	INTNO_INTWDTI   	0	/* EHb`hbOE^C} */
#define INTNO_INTLV1    	1	/* do */
#define INTNO_INTP0     	2	/* [q̓GbWo */
#define INTNO_INTP1     	3	/* [q̓GbWo */
#define INTNO_INTP2     	4	/* [q̓GbWo */
#define INTNO_INTP3     	5	/* [q̓GbWo */
#define INTNO_INTP4     	6	/* [q̓GbWo */
#define INTNO_INTP5     	7	/* [q̓GbWo */

#define INTNO_INTST2    	8	/* UART2 M̓]Cobt@󂫊 */
#define INTNO_INTCSI20  	8	/* CSI20 ̓]Cobt@󂫊 */
#define INTNO_IIC20     	8	/* IIC20 ̓] */

#define INTNO_INTSR2    	9	/* UART2 M̓] */
#define INTNO_INTSCI21  	9	/* CSI21 ̓] */
#define INTNO_INTIIC21  	9	/* IIC21 ̓] */

#define INTNO_SRE2      	10	/* UART2 M̒ʐMG[ */
#define INTNO_INTTM11H  	10	/* ^C}E`l11̃JEg܂̓Lv`(8rbg^C}쎞) */

#define INTNO_INTDMA0   	11	/* DMA0 ̓] */
#define INTNO_INTDMA1   	12	/* DMA1 ̓] */

#define INTNO_INTST0    	13	/* UART0 M̓]Cobt@󂫊 */
#define INTNO_INTCSI00  	13	/* CSI00 ̓], obt@󂫊 */
#define INTNO_INTIIC00  	13	/* IIC00 ̓] */

#define INTNO_INTSR0    	14	/* UART0 M̓]Cobt@󂫊 */
#define INTNO_INTCSI01  	14	/* CSI01 ̓], obt@󂫊 */
#define INTNO_INTIIC01  	14	/* IIC01 ̓] */

#define INTNO_SRE0      	15	/* UART0 M̒ʐMG[ */
#define INTNO_INTTM01H  	15	/* ^C}E`l01̃JEg܂̓Lv`(8rbg^C}쎞) */

#define INTNO_INTST1    	16	/* UART1 M̓]Cobt@󂫊 */
#define INTNO_INTCSI10  	16	/* CSI10 ̓], obt@󂫊 */
#define INTNO_INTIIC10  	16	/* IIC10 ̓] */

#define INTNO_INTSR1    	17	/* UART1 M̓]Cobt@󂫊 */
#define INTNO_INTCSI11  	17	/* CSI11 ̓], obt@󂫊 */
#define INTNO_INTIIC11  	17	/* IIC11 ̓] */

#define INTNO_SRE1      	18	/* UART1 M̒ʐMG[ */
#define INTNO_INTTM03H  	18	/* ^C}E`l03̃JEg܂̓Lv`(8rbg^C}쎞) */

#define INTNO_INTIICA0  	19	/* IICA0 ʐM */
#define INTNO_INTTM00   	20	/* ^C}E`l00̃JEg܂̓Lv` */
#define INTNO_INTTM01   	21	/* ^C}E`l01̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INTNO_INTTM02   	22	/* ^C}E`l02̃JEg܂̓Lv` */
#define INTNO_INTTM03   	23	/* ^C}E`l03̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INTNO_INTAD     	24	/* A/Dϊ */
#define INTNO_INTRTC     	25	/* A^CENbN̒M/A[vo */
#define INTNO_INTIT     	26	/* 12rbgEC^[oE^C}̃C^[oMo */
#define INTNO_INTKR     	27	/* L[E^[EMo */

#define INTNO_INTST3    	28	/* UART3 M̓]Cobt@󂫊 */
#define INTNO_INTCSI30  	28	/* CSI30 ̓], obt@󂫊 */
#define INTNO_INTIIC30  	28	/* IIC30 ̓] */

#define INTNO_INTSR3    	29	/* UART3 M̓]Cobt@󂫊 */
#define INTNO_INTCSI31  	29	/* CSI31 ̓], obt@󂫊 */
#define INTNO_INTIIC31  	29	/* IIC31 ̓] */

#define INTNO_INTTM13   	30	/* ^C}E`l13̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INTNO_INTTM04   	31	/* ^C}E`l04̃JEg܂̓Lv` */
#define INTNO_INTTM05   	32	/* ^C}E`l05̃JEg܂̓Lv` */
#define INTNO_INTTM06   	33	/* ^C}E`l06̃JEg܂̓Lv` */
#define INTNO_INTTM07   	34	/* ^C}E`l07̃JEg܂̓Lv` */

#define INTNO_INTP6     	35	/* [q̓GbWo */
#define INTNO_INTP7     	36	/* [q̓GbWo */
#define INTNO_INTP8     	37	/* [q̓GbWo */
#define INTNO_INTP9     	38	/* [q̓GbWo */
#define INTNO_INTP10     	39	/* [q̓GbWo */
#define INTNO_INTP11     	40	/* [q̓GbWo */

#define INTNO_INTTM10   	41	/* ^C}E`l10̃JEg܂̓Lv` */
#define INTNO_INTTM11   	42	/* ^C}E`l11̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INTNO_INTTM12   	43	/* ^C}E`l12̃JEg܂̓Lv` */

#define INTNO_SRE3      	44	/* UART3 M̒ʐMG[ */
#define INTNO_INTTM13H  	44	/* ^C}E`l13̃JEg܂̓Lv`(8rbg^C}쎞) */

#define INTNO_INTMD     	45	/* ZߏI/ϘaZʂ̃I[o[t[ */
#define INTNO_INTIICA1  	46	/* IICA1 ʐM */
#define INTNO_INTFL     	47	/* \ */
#define INTNO_INTDMA2   	48	/* DMA2̓] */
#define INTNO_INTDMA3   	49	/* DMA3̓] */
#define INTNO_INTTM14   	50	/* ^C}E`l14̃JEg܂̓Lv` */
#define INTNO_INTTM15   	51	/* ^C}E`l15̃JEg܂̓Lv` */
#define INTNO_INTTM16   	52	/* ^C}E`l16̃JEg܂̓Lv` */
#define INTNO_INTTM17   	53	/* ^C}E`l17̃JEg܂̓Lv` */


/*
 *  ݃nhԍ̒`
 */
#define	INHNO_INTWDTI   	INTNO_INTWDTI   	/* EHb`hbOE^C} */
#define INHNO_INTLV1    	INTNO_INTLV1    	/* do */
#define INHNO_INTP0     	INTNO_INTP0     	/* [q̓GbWo */
#define INHNO_INTP1     	INTNO_INTP1     	/* [q̓GbWo */
#define INHNO_INTP2     	INTNO_INTP2     	/* [q̓GbWo */
#define INHNO_INTP3     	INTNO_INTP3     	/* [q̓GbWo */
#define INHNO_INTP4     	INTNO_INTP4     	/* [q̓GbWo */
#define INHNO_INTP5     	INTNO_INTP5     	/* [q̓GbWo */
                        
#define INHNO_INTST2    	INTNO_INTST2    	/* UART2 M̓]Cobt@󂫊 */
#define INHNO_INTCSI20  	INTNO_INTCSI20  	/* CSI20 ̓]Cobt@󂫊 */
#define INHNO_IIC20     	INTNO_IIC20     	/* IIC20 ̓] */
                        
#define INHNO_INTSR2    	INTNO_INTSR2    	/* UART2 M̓] */
#define INHNO_INTSCI21  	INTNO_INTSCI21  	/* CSI21 ̓] */
#define INHNO_INTIIC21  	INTNO_INTIIC21  	/* IIC21 ̓] */
                        
#define INHNO_SRE2      	INTNO_SRE2      	/* UART2 M̒ʐMG[ */
#define INHNO_INTTM11H  	INTNO_INTTM11H  	/* ^C}E`l11̃JEg܂̓Lv`(8rbg^C}쎞) */
                        
#define INHNO_INTDMA0   	INTNO_INTDMA0   	/* DMA0 ̓] */
#define INHNO_INTDMA1   	INTNO_INTDMA1   	/* DMA1 ̓] */
                        
#define INHNO_INTST0    	INTNO_INTST0    	/* UART0 M̓]Cobt@󂫊 */
#define INHNO_INTCSI00  	INTNO_INTCSI00  	/* CSI00 ̓], obt@󂫊 */
#define INHNO_INTIIC00  	INTNO_INTIIC00  	/* IIC00 ̓] */
                        
#define INHNO_INTSR0    	INTNO_INTSR0    	/* UART0 M̓]Cobt@󂫊 */
#define INHNO_INTCSI01  	INTNO_INTCSI01  	/* CSI01 ̓], obt@󂫊 */
#define INHNO_INTIIC01  	INTNO_INTIIC01  	/* IIC01 ̓] */
                        
#define INHNO_SRE0      	INTNO_SRE0      	/* UART0 M̒ʐMG[ */
#define INHNO_INTTM01H  	INTNO_INTTM01H  	/* ^C}E`l01̃JEg܂̓Lv`(8rbg^C}쎞) */
                        
#define INHNO_INTST1    	INTNO_INTST1    	/* UART1 M̓]Cobt@󂫊 */
#define INHNO_INTCSI10  	INTNO_INTCSI10  	/* CSI10 ̓], obt@󂫊 */
#define INHNO_INTIIC10  	INTNO_INTIIC10  	/* IIC10 ̓] */
                        
#define INHNO_INTSR1    	INTNO_INTSR1    	/* UART1 M̓]Cobt@󂫊 */
#define INHNO_INTCSI11  	INTNO_INTCSI11  	/* CSI11 ̓], obt@󂫊 */
#define INHNO_INTIIC11  	INTNO_INTIIC11  	/* IIC11 ̓] */
                        
#define INHNO_SRE1      	INTNO_SRE1      	/* UART1 M̒ʐMG[ */
#define INHNO_INTTM03H  	INTNO_INTTM03H  	/* ^C}E`l03̃JEg܂̓Lv`(8rbg^C}쎞) */
                        
#define INHNO_INTIICA0  	INTNO_INTIICA0  	/* IICA0 ʐM */
#define INHNO_INTTM00   	INTNO_INTTM00   	/* ^C}E`l00̃JEg܂̓Lv` */
#define INHNO_INTTM01   	INTNO_INTTM01   	/* ^C}E`l01̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INHNO_INTTM02   	INTNO_INTTM02   	/* ^C}E`l02̃JEg܂̓Lv` */
#define INHNO_INTTM03   	INTNO_INTTM03   	/* ^C}E`l03̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INHNO_INTAD     	INTNO_INTAD     	/* A/Dϊ */
#define INHNO_INTRTC     	INTNO_INTRTC    	/* A^CENbN̒M/A[vo */
#define INHNO_INTIT     	INTNO_INTIT     	/* 12rbgEC^[oE^C}̃C^[oMo */
#define INHNO_INTKR     	INTNO_INTKR     	/* L[E^[EMo */
                        
#define INHNO_INTST3    	INTNO_INTST3    	/* UART3 M̓]Cobt@󂫊 */
#define INHNO_INTCSI30  	INTNO_INTCSI30  	/* CSI30 ̓], obt@󂫊 */
#define INHNO_INTIIC30  	INTNO_INTIIC30  	/* IIC30 ̓] */
                        
#define INHNO_INTSR3    	INTNO_INTSR3    	/* UART3 M̓]Cobt@󂫊 */
#define INHNO_INTCSI31  	INTNO_INTCSI31  	/* CSI31 ̓], obt@󂫊 */
#define INHNO_INTIIC31  	INTNO_INTIIC31  	/* IIC31 ̓] */
                        
#define INHNO_INTTM13   	INTNO_INTTM13   	/* ^C}E`l13̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INHNO_INTTM04   	INTNO_INTTM04   	/* ^C}E`l04̃JEg܂̓Lv` */
#define INHNO_INTTM05   	INTNO_INTTM05   	/* ^C}E`l05̃JEg܂̓Lv` */
#define INHNO_INTTM06   	INTNO_INTTM06   	/* ^C}E`l06̃JEg܂̓Lv` */
#define INHNO_INTTM07   	INTNO_INTTM07   	/* ^C}E`l07̃JEg܂̓Lv` */
                        
#define INHNO_INTP6     	INTNO_INTP6     	/* [q̓GbWo */
#define INHNO_INTP7     	INTNO_INTP7     	/* [q̓GbWo */
#define INHNO_INTP8     	INTNO_INTP8     	/* [q̓GbWo */
#define INHNO_INTP9     	INTNO_INTP9     	/* [q̓GbWo */
#define INHNO_INTP10     	INTNO_INTP10    	/* [q̓GbWo */
#define INHNO_INTP11     	INTNO_INTP11    	/* [q̓GbWo */
                        
#define INHNO_INTTM10   	INTNO_INTTM10   	/* ^C}E`l10̃JEg܂̓Lv` */
#define INHNO_INTTM11   	INTNO_INTTM11   	/* ^C}E`l11̃JEg܂̓Lv`(16rbg/8rbg^C}쎞) */
#define INHNO_INTTM12   	INTNO_INTTM12   	/* ^C}E`l12̃JEg܂̓Lv` */
                        
#define INHNO_SRE3      	INTNO_SRE3      	/* UART3 M̒ʐMG[ */
#define INHNO_INTTM13H  	INTNO_INTTM13H  	/* ^C}E`l13̃JEg܂̓Lv`(8rbg^C}쎞) */
                        
#define INHNO_INTMD     	INTNO_INTMD     	/* ZߏI/ϘaZʂ̃I[o[t[ */
#define INHNO_INTIICA1  	INTNO_INTIICA1  	/* IICA1 ʐM */
#define INHNO_INTFL     	INTNO_INTFL     	/* \ */
#define INHNO_INTDMA2   	INTNO_INTDMA2   	/* DMA2̓] */
#define INHNO_INTDMA3   	INTNO_INTDMA3   	/* DMA3̓] */
#define INHNO_INTTM14   	INTNO_INTTM14   	/* ^C}E`l14̃JEg܂̓Lv` */
#define INHNO_INTTM15   	INTNO_INTTM15   	/* ^C}E`l15̃JEg܂̓Lv` */
#define INHNO_INTTM16   	INTNO_INTTM16   	/* ^C}E`l16̃JEg܂̓Lv` */
#define INHNO_INTTM17   	INTNO_INTTM17   	/* ^C}E`l17̃JEg܂̓Lv` */


/*
 *  ݐ䃌WX^`
 */
#define TADR_IF0L	0xfffe0 	// ݗvtOEWX^
#define TADR_IF2L	0xfffd0 	// ݗvtOEWX^
#define TADR_MK0L	0xfffe4 	// ݃}XNEtOEWX^
#define TADR_MK2L	0xfffd4 	// ݃}XNEtOEWX^
#define TADR_PR00L	0xfffe8 	// D揇ʎwtOEWX^
#define TADR_PR02L	0xfffd8 	// D揇ʎwtOEWX^
#define TADR_EGP0	0xfff38 	// OݗオGbWWX^
#define TADR_EGP1	0xfff3a 	// OݗオGbWWX^


#define TADR_PER0	0xf00f0 	// ӃCl[uWX^0

#define TBIT_PER0_TAU0EN	UINT8_C(0x01)	// ^C}EACEjbg0̓̓NbN
#define TBIT_PER0_SAU0EN	UINT8_C(0x04)	// VAEACEjbg0̓̓NbN

/*
 *  NbNH
 */
#define TADR_CMC	0xfffa0 	// NbN샂[h䃌WX^
#define TADR_CKC	0xfffa4 	// NbN샂[h䃌WX^
#define TADR_CSC	0xfffa1 	// NbNXe[^X䃌WX^
#define TADR_OSTC	0xfffa2 	// U莞ԃJE^ԃWX^

/*
 *  ^C}EAC֘AWX^(VXeeBbNp)
 */
#define TADR_TPS0	0xf01b6 	// ^C}ENbNIWX^0
#define TADR_TMR00	0xf0190 	// ^C}E[hEWX^00
#define TADR_TDR00	0xfff18 	// ^C}Ef[^EWX^00
#define TADR_TS0	0xf01b2 	// ^C}E`l~WX^0
#define TADR_TT0	0xf01b4 	// ^C}E`l~WX^0

#define TBIT_TTm_TTm0	UINT16_C(0x0001)
#define TBIT_TSm_TSm0	UINT16_C(0x0001)
#define TBIT_TTmL_TTm0	UINT8_C(0x01)
#define TBIT_TSmL_TSm0	UINT8_C(0x01)

/*
 *  VAEAC֘AWX^
 */
#define TADR_SPS0	0xf0126 	// VANbNIWX^
#define TADR_SMR00	0xf0110 	// VA[hWX^
#define TADR_SMR01	0xf0112 	// VA[hWX^

#define TADR_SCR00	0xf0118 	// VAʐMݒ背WX^
#define TADR_SCR01	0xf011a 	// VAʐMݒ背WX^

#define TADR_SDR00	0xfff10 	// VAf[^WX^0
#define TADR_SDR01	0xfff12 	// VAf[^WX^0

#define TADR_SOL0	0xf0134 	// VAo̓xWX^0
#define TADR_SO0	0xf0128 	// VAo̓WX^0
#define TADR_SOE0	0xf012a 	// VAo͋WX^0
#define TADR_SSR00	0xf0100 	// VAXe[^XWX^00
#define TADR_SSR01	0xf0102 	// VAXe[^XWX^01

#define TADR_SS0	0xf0122 	// VA`lJnWX^0
#define TADR_ST0	0xf0124 	// VA`l~WX^0

#define TADR_SIR01	0xf010a 	// VAEtOENAEgKEWX^01 

#define TADR_NFEN0	0xf0070 	// mCYEtB^WX^0

#define TBIT_SSRmn_BFF	UINT16_C(0x0020)	// `lñobt@WX^ԕ\tO
#define TBIT_SSRmn_TSF	UINT16_C(0x0040)	// `ln̒ʐMԕ\tO
#define TBIT_SSRmnL_BFF	UINT8_C(0x20)	// `lñobt@WX^ԕ\tO
#define TBIT_SSRmnL_TSF	UINT8_C(0x40)	// `ln̒ʐMԕ\tO

#define TBIT_SCRmn_TXEmn	UINT16_C(0x8000)	// `ln̓샂[h(M)
#define TBIT_SCRmn_RXEmn	UINT16_C(0x4000)	// `ln̓샂[h(M)

/*
 * I/O|[g
 */
#define TADR_PU0 	0xf0030
#define TADR_POM0 	0xf0050
#define TADR_PMC0	0xf0060
#define TADR_PM0	0xfff20
#define TADR_PM1	0xfff21
#define TADR_P0 	0xfff00
#define TADR_P1  	0xfff01
#define TADR_POM1	0xf0051

#define TADR_PIOR	0xf0077

#define TBIT_PIOR_PIOR1	UINT8_C(0x02)

/*
 *  ėp|[gWX^
 */
#define TBIT_BIT0	0x01
#define TBIT_BIT1	0x02
#define TBIT_BIT2	0x04
#define TBIT_BIT3	0x08
#define TBIT_BIT4	0x10
#define TBIT_BIT5	0x20
#define TBIT_BIT6	0x40
#define TBIT_BIT7	0x80


#endif	/* TOPPERS_RL78G13_H */
